/*! \file OptionStruct.h 
 *  \brief: header file for optionstruct object
 */

#ifndef _OPTIONSTRUCT_H_
#define _OPTIONSTRUCT_H_

/*Headers:{{{1*/
#include "../../include/include.h"
#include "../../shared/Exceptions/exceptions.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

#include "./Option.h"
/*}}}*/

class OptionStruct: public Option {

	public:

		Options** values;

		/*OptionStruct constructors, destructors {{{1*/
		OptionStruct();
		~OptionStruct();
		/*}}}*/
		/*Object virtual functions definitions:{{{1*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		int   Id(){_error_("Not implemented yet");};
		int   MyRank(){_error_("Not implemented yet");};
		int   ObjectEnum(){return OptionStructEnum;};
		Object* copy(){_error_("Not implemented yet");};
		/*}}}*/

		/*virtual functions: */
		char* Name();
		int   NumEl();
		int   NDims();
		int*  Size();
		void  Get(double* pvalue){_error_("An OptionStruct object cannot return a double");};
		void  Get(bool* pvalue){  _error_("An OptionStruct object cannot return a bool");};
		void  Get(char** pvalue){ _error_("An OptionStruct object cannot return a string");};
		void  Get(char*** ppvalue,int *pnumel){ _error_("An OptionStruct object cannot return a string vec");};
		void  Get(double** pvalue,int *pnumel){ _error_("An OptionStruct object cannot return a double vec");};
		void  Get(Options** pvalue);
		void  Get(Options*** ppvalue,int *pnumel);

};
#endif  /* _OPTIONSTRUCT_H */

